;################################################################################
;#										#
;# LCD init for AX81								#
;# copyright (c) 2011 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;-------------------------------------------------------------------------------
;timer configuration for LCD
;-------------------------------------------------------------------------------
init_lcd:	ldi	XL,0x10
		out	DPORT,XL		;VEE disabled
		ldi	XL,0xFF
		out	DDDR,XL

		ldi	XH,0xc2			;FAST-PWM-Mode 14 (PWM channel B)
		sts	TCCR1A,XH
		ldi	XH,0x19			;FAST-PWM-Mode (no prescaler)
		sts	TCCR1B,XH
		ldi	ZH,HIGH(1388)
		ldi	ZL,LOW(1388)
		sts	ICR1H,ZH
		sts	ICR1L,ZL

		ldi	ZH,72			;1 hsync length VGA
		sts	OCR1AH,const_0		;we use only 8 bits
		sts	OCR1AL,ZH

		ldi	XL,0x01
		sts	TIMSK1,XL		;enable TOV INT
		ret

