;################################################################################
;#										#
;# VGA init for AX81 (internal shift register)					#
;# copyright (c) 2011 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public				#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;-------------------------------------------------------------------------------
;timer configuration for VGA
;-------------------------------------------------------------------------------
init_vga:	ldi	XH,0xc2			;FAST-PWM-Mode 14 (PWM channel B)
		sts	TCCR1A,XH
		ldi	XH,0x19			;FAST-PWM-Mode (no prescaler)
		sts	TCCR1B,XH
		ldi	ZH,HIGH(libmio_counter_v)
		ldi	ZL,LOW(libmio_counter_v)
		sts	ICR1H,ZH
		sts	ICR1L,ZL

		ldi	ZH,libmio_vga_hslen	;1 hsync length VGA
		sts	OCR1AH,const_0		;we use only 8 bits
		sts	OCR1AL,ZH

		ldi	ZH,libmio_vga_int	;video start for VGA
		sts	OCR1BH,const_0		;we use only 8 bits
		sts	OCR1BL,ZH

		ldi	XL,0x04
		sts	TIMSK1,XL		;enable CHB INT

		cbi	MODEPORT,MODEPIN

		sts	UBRR1H,const_0
		sts	UBRR1L,const_0
		ldi	XL,0x18
		sts	UCSR1B,XL
		ldi	XL,0xc2
		sts	UCSR1C,XL
		sts	UBRR1H,const_0
		sts	UBRR1L,const_0

		sbi	VSDDR,VSPIN
		sbi	HSDDR,HSPIN
		cbi	VODDR,VOPIN
		cbi	VDDR,7

		ret
